import javax.microedition.lcdui.*;
import java.util.Calendar;

class midletCanvas extends Canvas implements CommandListener {
 public static boolean first;
 private midlet midlet;
 private Display dpy;
 private Displayable prev;
 private options options;
 private tonePlayer t = new tonePlayer ();
 private midiPlayer mp = new midiPlayer ("/sound1.mid");
 private midiPlayer before,hit;
 private int count_curant=0, sec_curant=0;

 private Command cmdExit = new Command("", Command.EXIT, 1);
 private Command cmdOptions = new Command("", Command.ITEM, 2);
 private Command cmdAbout = new Command(" ", Command.ITEM, 2);

 private Font font;
 private numericTimer myTimer;

 private int width, height, fHeight, top, hour, min, sec, lastsec, nexthour, nextmin, nextsec, drawmin, drawsec;
 public int drawhour;
 private random r;
 private matrixClock mClock;

 public midletCanvas (midlet midlet) {
  this.midlet = midlet;
  dpy = Display.getDisplay(midlet);
  prev = dpy.getCurrent();
  options = new options (false);
  setFullScreenMode (true);
  width=getWidth();
  height=getHeight();
  addCommand(cmdExit);
  addCommand(cmdOptions);
  addCommand(cmdAbout);
  setCommandListener(this);
  font = Font.getFont (Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_LARGE);
  mClock = new matrixClock (width);
  getClockHeight ();
  top = (height-fHeight)/2;
  myTimer = new numericTimer ();
  drawhour = myTimer.getHour ()-1;
  if (drawhour<0) drawhour=23;
  drawmin  = myTimer.getMin ();
  drawsec  = myTimer.getSec ();
  r = new random ();
  first=true;
 }

 private void getNextTime () {
  int [] n = new int [2];
  if (options.fromhour==0) n = myTimer.nextPeriodicTime (options.starthour,options.startmin,hour,min,options.mininterval);
  else n =  myTimer.nextTime (hour,min,options.mininterval);
  nexthour = n[0];
  nextmin = n[1];
//System.out.println ("getNextTime:"+nexthour+":"+nextmin);
 }

 private void getFirstTime () {
  int [] n = new int [2];
  boolean b=myTimer.timeBetween (options.starthour, options.startmin, hour, min, options.endhour,options.endmin);
  if (b==true) getNextTime ();
  else {
   if (options.fromhour==0) {
    nexthour=options.starthour;
    nextmin=options.startmin;
   }
   else {
    n=myTimer.nextPeriodicTime (hour,min,options.starthour,options.startmin,options.mininterval);
    nexthour = n[0];
    nextmin = n[1];
   }
//System.out.println ("getFirstTime:"+nexthour+":"+nextmin);
  }
 }

 private void getClockHeight () {
  if (options.style==0) fHeight = font.getHeight()+4;
  else fHeight=mClock.getHeight()+4;
  if (top+fHeight>height) top=height-fHeight;
 }

 private void draw (Graphics g) {
  getClockHeight ();
  g.setColor(0xFFFFFF);
  g.fillRect(0,top,width,fHeight);
  g.setColor(0x000000);
  if (options.style==0) {
   g.setFont (font);
   g.drawString(myTimer.getTimeString(hour,min), width/2, top + 2, Graphics.TOP|Graphics.HCENTER);
  }
  else mClock.draw (g, top +2, hour, min);
 }

 private void clear (Graphics g) {
  g.setColor(0x000000);
  getClockHeight ();
  g.fillRect(0,top,width,fHeight);
 }

 protected void paint (Graphics g) {
  hour = myTimer.getHour ();
  min  = myTimer.getMin ();
  sec  = myTimer.getSec ();
//System.out.println (""+hour+":"+min+":"+sec+","+lastsec);
  if (first==true) {
   g.setColor(0x000000);
   g.fillRect(0,0,width,height);
   getFirstTime ();
   draw (g);
   lastsec=sec-1;
   first=false;
  }

  if (sec!=lastsec) { //   ?

   if (sec_curant > 0) {
    sec_curant--;
    if (sec_curant==0) {
     sec_curant = -1;
     before.stop();
    }
   }
   else if (count_curant>0) {
    if (count_curant%2==0) {
     if (sec_curant == 0) hit.stop ();
     else sec_curant = 0;
     hit = new midiPlayer ("/hit.mid");
     hit.play ();
    }
    count_curant--;
    if (count_curant==0) count_curant=-1;
   }
   else if (count_curant==-1) {
    count_curant=0;
    hit.stop ();
   }

   if (sec<lastsec) {
    if (min==0) {
     if (options.curants>0 && myTimer.timeBetween(options.starthour, options.startmin, hour, min, options.endhour,options.endmin)==true) {
      before = new midiPlayer ("/before.mid");
      before.play ();
      sec_curant = 5;
      count_curant = 24;
      if (hour%12!=0) count_curant=(hour%12)*2;
//System.out.println ("curants:"+sec_curant+" "+count_curant);
     }
    }
   }

   //,    
   if (myTimer.timeBetween (options.starthour, options.startmin, hour, min, options.endhour,options.endmin)==true) {
    if (myTimer.compareTimes (hour,min,nexthour,nextmin)==0) {
     getNextTime ();
     draw (g);
     if ((options.sound>0) && (sec_curant==0) && (count_curant==0)) {
      switch (options.sound) {
       case 1: 
        t.setDuration (100);
        t.play (t.notes[0]);
       break;
       case 2: 
        t.setDuration (1000); 
        t.play (t.notes[3]);
       break;
       case 3:
        mp.play ();
       break;
      }
     }
     if (options.vibrator>0) dpy.vibrate (200); //MIDP 2.0
    }
   }
   // ,   
   if (myTimer.secDifference(hour,min,sec,drawhour,drawmin,drawsec)>=options.secinterval) {
    clear (g);
    top = r.get (height-fHeight);
    draw (g);
    drawsec=sec; drawmin=min; drawhour=hour;
   }
   //  
   else if (myTimer.compareTimes (hour,min,drawhour,drawmin)!=0) {
    draw (g);
   }
   lastsec=sec;
  }
 }
  
 public void commandAction(Command c, Displayable d)  {
  if (c==cmdExit) {
   mp.stop ();
   midlet.exitMIDlet();
  }
  else if (c==cmdOptions) {
   optionsForm optionsForm = new optionsForm (midlet, this);
   sec_curant=count_curant=0;
   dpy.setCurrent (optionsForm);
  }
  else if (c==cmdAbout) {
   errorForm er = new errorForm (dpy, this, " ");
   sec_curant=count_curant=0;
   er.show (
    "            .\n"+
    "(C) PerS, pers@mail.ru"
   );
  }
 }

}
